/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: getlpar_infoPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the getlpar_infoPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=getlpar_info.class)
public class getlpar_infoPointer extends StructurePointer {

	// NULL
	public static final getlpar_infoPointer NULL = new getlpar_infoPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected getlpar_infoPointer(long address) {
		super(address);
	}

	public static getlpar_infoPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static getlpar_infoPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static getlpar_infoPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new getlpar_infoPointer(address);
	}

	public getlpar_infoPointer add(long count) {
		return getlpar_infoPointer.cast(address + (getlpar_info.SIZEOF * count));
	}

	public getlpar_infoPointer add(Scalar count) {
		return add(count.longValue());
	}

	public getlpar_infoPointer addOffset(long offset) {
		return getlpar_infoPointer.cast(address + offset);
	}

	public getlpar_infoPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public getlpar_infoPointer sub(long count) {
		return getlpar_infoPointer.cast(address - (getlpar_info.SIZEOF * count));
	}

	public getlpar_infoPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public getlpar_infoPointer subOffset(long offset) {
		return getlpar_infoPointer.cast(address - offset);
	}

	public getlpar_infoPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public getlpar_infoPointer untag(long mask) {
		return getlpar_infoPointer.cast(address & ~mask);
	}

	public getlpar_infoPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return getlpar_info.SIZEOF;
	}

	// Implementation methods

	// U16 lpar_flags
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_lpar_flagsOffset_", declaredType="U16")
	public U16 lpar_flags() throws CorruptDataException {
		return new U16(getShortAtOffset(getlpar_info._lpar_flagsOffset_));
	}

	// U16 lpar_flags
	public U16Pointer lpar_flagsEA() throws CorruptDataException {
		return U16Pointer.cast(nonNullFieldEA(getlpar_info._lpar_flagsOffset_));
	}

	// U8* lpar_name
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_lpar_nameOffset_", declaredType="U8*")
	public U8Pointer lpar_name() throws CorruptDataException {
		return U8Pointer.cast(getPointerAtOffset(getlpar_info._lpar_nameOffset_));
	}

	// U8* lpar_name
	public PointerPointer lpar_nameEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(getlpar_info._lpar_nameOffset_));
	}

	// U16 lpar_namesz
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_lpar_nameszOffset_", declaredType="U16")
	public U16 lpar_namesz() throws CorruptDataException {
		return new U16(getShortAtOffset(getlpar_info._lpar_nameszOffset_));
	}

	// U16 lpar_namesz
	public U16Pointer lpar_nameszEA() throws CorruptDataException {
		return U16Pointer.cast(nonNullFieldEA(getlpar_info._lpar_nameszOffset_));
	}

	// I32 lpar_num
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_lpar_numOffset_", declaredType="I32")
	public IDATA lpar_num() throws CorruptDataException {
		return new I32(getIntAtOffset(getlpar_info._lpar_numOffset_));
	}

	// I32 lpar_num
	public IDATAPointer lpar_numEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(getlpar_info._lpar_numOffset_));
	}

	// I32[] rsvd
	public IDATAPointer rsvdEA() throws CorruptDataException {
		return I32Pointer.cast(nonNullFieldEA(getlpar_info._rsvdOffset_));
	}

}
